Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp	(revision 115)
@@ -19,16 +19,17 @@
 #undef  FUNCTION
 #define FUNCTION "Write_unit::Parameters"
-  Parameters::Parameters (uint32_t size_write_queue   ,
-			  uint32_t size_execute_queue ,
-			  uint32_t nb_context         ,
-			  uint32_t nb_front_end       ,
-			  uint32_t nb_ooo_engine      ,
-			  uint32_t nb_packet          ,
-			  uint32_t size_general_data  ,
-			  uint32_t nb_general_register,
-			  uint32_t size_special_data  ,
-			  uint32_t nb_special_register,
-			  uint32_t nb_bypass_write    ,
-                          bool     is_toplevel        ):
+  Parameters::Parameters (uint32_t              size_write_queue   ,
+			  uint32_t              size_execute_queue ,
+			  uint32_t              nb_context         ,
+			  uint32_t              nb_front_end       ,
+			  uint32_t              nb_ooo_engine      ,
+			  uint32_t              nb_packet          ,
+			  uint32_t              size_general_data  ,
+			  uint32_t              nb_general_register,
+			  uint32_t              size_special_data  ,
+			  uint32_t              nb_special_register,
+			  uint32_t              nb_bypass_write    ,
+			  write_queue::Twrite_queue_scheme_t write_queue_scheme ,
+			  bool                  is_toplevel):
     behavioural::Parameters("Write_unit")
   {
@@ -44,5 +45,6 @@
     _nb_special_register          = nb_special_register;
     _nb_bypass_write              = nb_bypass_write    ;
-                                  
+    _write_queue_scheme           = write_queue_scheme ;
+
     _nb_gpr_write                 = 1;
     _nb_spr_write                 = 1;
@@ -50,24 +52,27 @@
     _have_component_execute_queue = _size_execute_queue > 0;
                                   
-    _param_write_queue  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_write_unit::write_unit::write_queue  ::Parameters(_size_write_queue   ,
-																		    _nb_context         ,
-																		    _nb_front_end       ,
-																		    _nb_ooo_engine      ,
-																		    _nb_packet          ,
-																		     size_general_data  ,
-																		    _nb_general_register,
-																		     size_special_data  ,
-																		    _nb_special_register,
-																		    _nb_bypass_write    );
+    _param_write_queue  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_write_unit::write_unit::write_queue  ::Parameters
+      (_size_write_queue   ,
+       _nb_context         ,
+       _nb_front_end       ,
+       _nb_ooo_engine      ,
+       _nb_packet          ,
+        size_general_data  ,
+       _nb_general_register,
+        size_special_data  ,
+       _nb_special_register,
+       _nb_bypass_write    ,
+       _write_queue_scheme );
     
     if (_have_component_execute_queue)
-      _param_execute_queue  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_write_unit::write_unit::execute_queue::Parameters(_size_execute_queue   ,
-																			_nb_context         ,
-																			_nb_front_end       ,
-																			_nb_ooo_engine      ,
-																			_nb_packet          ,
-																			 size_general_data  ,
-																			 size_special_data  );
-
+      _param_execute_queue  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_write_unit::write_unit::execute_queue::Parameters
+	(_size_execute_queue ,
+	 _nb_context         ,
+	 _nb_front_end       ,
+	 _nb_ooo_engine      ,
+	 _nb_packet          ,
+	  size_general_data  ,
+	  size_special_data  );
+    
     test();
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_allocation.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_allocation.cpp	(revision 115)
@@ -111,5 +111,5 @@
      if (usage_is_set(_usage,USE_SYSTEMC))
        {
-         ALLOC3(_destination,std::list<destination_t>,_param->_nb_read_unit,_param->_nb_thread,_param->_nb_type);;
+         ALLOC3(_destination,std::list<destination_t>,_param->_nb_read_unit,_param->_nb_thread,_param->_nb_type);
        }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_deallocation.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_deallocation.cpp	(revision 115)
@@ -69,5 +69,5 @@
          DELETE2_SIGNAL(out_EXECUTE_UNIT_IN_NUM_REG_RD           , _param->_nb_execute_unit, _param->_nb_execute_unit_port [it1],_param->_size_general_register );
 
-         DELETE3(_destination,_param->_nb_read_unit,_param->_nb_thread,_param->_nb_type);;
+         DELETE3(_destination,_param->_nb_read_unit,_param->_nb_thread,_param->_nb_type);
       }
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_min.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_min.cfg	(revision 115)
@@ -25,4 +25,5 @@
 1	1	+1	# size_execute_queue                         [0]       [nb_write_unit]
 1	1	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [0]       [nb_write_unit]
 1	1	+1	# nb_gpr_bank                                	       
 1	1	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2a.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2a.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2a.cfg	(revision 115)
@@ -25,4 +25,5 @@
 4	4	*4	# size_execute_queue                         [0]       [nb_write_unit]
 2	2	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [0]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 1	1	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2b.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2b.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_2b.cfg	(revision 115)
@@ -43,4 +43,8 @@
 1	1	+1	# nb_bypass_write                            [2]       [nb_write_unit]
 4	4	+1	# nb_bypass_write                            [3]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [1]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [2]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [3]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 2	2	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_3a.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_3a.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_3a.cfg	(revision 115)
@@ -44,4 +44,8 @@
 1	1	+1	# nb_bypass_write                            [2]       [nb_write_unit]
 4	4	+1	# nb_bypass_write                            [3]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [1]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [2]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [3]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 2	2	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_6a.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_6a.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_1_execute_6a.cfg	(revision 115)
@@ -47,4 +47,8 @@
 1	1	+1	# nb_bypass_write                            [2]       [nb_write_unit]
 4	4	+1	# nb_bypass_write                            [3]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [1]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [2]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [3]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 2	2	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2a.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2a.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2a.cfg	(revision 115)
@@ -25,4 +25,5 @@
 4	4	*4	# size_execute_queue                         [0]       [nb_write_unit]
 2	2	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [0]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 1	1	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2b.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2b.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2b.cfg	(revision 115)
@@ -25,4 +25,5 @@
 4	4	*4	# size_execute_queue                         [0]       [nb_write_unit]
 2	2	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+0	1	+1	# write_queue_scheme                         [0]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 1	1	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg	(revision 115)
@@ -25,4 +25,5 @@
 4	4	*4	# size_execute_queue                         [0]       [nb_write_unit]
 2	2	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+0	0	+1	# write_queue_scheme                         [0]       [nb_write_unit]
 4	4	+1	# nb_gpr_bank                                	       
 1	1	+1	# nb_gpr_port_read_by_bank                   	       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 115)
@@ -39,4 +39,5 @@
   err (_(" * size_execute_queue                        [nb_write_unit]                                        (uint32_t           )\n"));
   err (_(" * nb_bypass_write                           [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * write_queue_scheme                        [nb_write_unit]                                        (Twrite_queue_scheme_t)\n"));
   err (_(" * nb_gpr_bank                                                                                      (uint32_t           )\n"));
   err (_(" * nb_gpr_port_read_by_bank                                                                         (uint32_t           )\n"));
@@ -97,5 +98,5 @@
 		       1*nb_functionnal_unit+
 		       8*nb_load_store_unit+
-		       3*nb_write_unit+
+		       4*nb_write_unit+
 		       4*nb_ooo_engine+
 // 		       sum_execute_unit_port*nb_write_unit+
@@ -167,5 +168,5 @@
 	       1*nb_functionnal_unit+
 	       8*nb_load_store_unit+
-	       3*nb_write_unit+
+	       4*nb_write_unit+
 	       4*nb_ooo_engine+
 	       sum_execute_unit_port*nb_write_unit+
@@ -196,4 +197,8 @@
   for (uint32_t i=0; i<nb_write_unit; i++)
     nb_bypass_write    [i] = atoi(argv[x++]);
+
+  multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t * write_queue_scheme    = new multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t [nb_write_unit];
+  for (uint32_t i=0; i<nb_write_unit; i++)
+    write_queue_scheme    [i] = fromString<multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t>(argv[x++]);
 
   uint32_t nb_gpr_bank                = atoi(argv[x++]);
@@ -339,4 +344,5 @@
 	 size_execute_queue                            ,
 	 nb_bypass_write                               ,
+	 write_queue_scheme                            ,
 	 
 	 nb_gpr_bank                                   ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h	(revision 115)
@@ -73,4 +73,6 @@
   public : uint32_t            * _size_execute_queue                            ; //[nb_write_unit]
   public : uint32_t            * _nb_bypass_write                               ; //[nb_write_unit]
+  public : multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t * _write_queue_scheme; //[nb_write_unit]
+
     //  * register_unit                                                               
   public : uint32_t              _nb_gpr_read                                   ;
@@ -172,5 +174,6 @@
                         uint32_t            * size_execute_queue                            ,//[nb_write_unit]
                         uint32_t            * nb_bypass_write                               ,//[nb_write_unit]
-                        
+			multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t * write_queue_scheme,//[nb_write_unit]
+
                         uint32_t              nb_gpr_bank                                   ,
                         uint32_t              nb_gpr_port_read_by_bank                      ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 115)
@@ -50,4 +50,5 @@
 			  uint32_t            * size_execute_queue                        ,//[nb_write_unit]
 			  uint32_t            * nb_bypass_write                           ,//[nb_write_unit]
+			  multi_write_unit::write_unit::write_queue::Twrite_queue_scheme_t * write_queue_scheme,//[nb_write_unit]
 			  
 			  uint32_t              nb_gpr_bank                               ,
@@ -108,4 +109,5 @@
     _size_execute_queue                         = size_execute_queue                   ;
     _nb_bypass_write                            = nb_bypass_write                      ;
+    _write_queue_scheme                         = write_queue_scheme                   ;
                                                 
     _nb_gpr_bank                                = nb_gpr_bank                          ;
@@ -456,6 +458,6 @@
 	  size_special_data          ,
 	 _max_nb_special_register    ,
-	 _nb_bypass_write         [i]);
-
+	 _nb_bypass_write         [i],
+	 _write_queue_scheme      [i]);
 
     log_printf(TRACE,Execute_loop,FUNCTION,"Parameters : read_unit_to_execution_unit");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 115)
@@ -112,5 +112,6 @@
                   }
 
-              DELETE1(reg_QUEUE,_param->_nb_bank); break;
+              DELETE1(reg_QUEUE,_param->_nb_bank); 
+	      break;
             } 
           }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp	(revision 115)
@@ -63,9 +63,11 @@
             // ....... max ...X... min ....... KO
             
-            Tcontrol_t   is_valid      = ((depth == depth_min) or
-                                          depth_full or
-                                          ((depth_min <= depth_max)?
-                                           ((depth >= depth_min) and (depth <=depth_max)):
-                                           ((depth >= depth_min) or  (depth <=depth_max))));
+	    Tcontrol_t is_valid = true;
+
+//             Tcontrol_t   is_valid      = ((depth == depth_min) or
+//                                           depth_full or
+//                                           ((depth_min <= depth_max)?
+//                                            ((depth >= depth_min) and (depth <=depth_max)):
+//                                            ((depth >= depth_min) or  (depth <=depth_max))));
             //Tcontrol_t is_valid        = ((depth == depth_min) or 
             //                              ((depth_min < depth_max)?
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp	(revision 115)
@@ -66,9 +66,10 @@
               // ....... max ...X... min ....... KO
               
-              Tcontrol_t   is_valid      = ((depth == depth_min) or
-                                            depth_full or
-                                            ((depth_min <= depth_max)?
-                                             ((depth >= depth_min) and (depth <=depth_max)):
-                                             ((depth >= depth_min) or  (depth <=depth_max))));
+	      Tcontrol_t is_valid = true;
+//               Tcontrol_t   is_valid      = ((depth == depth_min) or
+//                                             depth_full or
+//                                             ((depth_min <= depth_max)?
+//                                              ((depth >= depth_min) and (depth <=depth_max)):
+//                                              ((depth >= depth_min) or  (depth <=depth_max))));
               //Tcontrol_t is_valid        = ((depth == depth_min) or 
               //                              ((depth_min < depth_max)?
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_deallocation.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_deallocation.cpp	(revision 115)
@@ -63,10 +63,12 @@
     if (_param->_have_component_victim)
       {
-    delete [] _component_sort;
-    delete _component_victim;
+	for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
+	  delete _component_sort [i];
+	delete [] _component_sort;
+	delete _component_victim;
       }
     delete _component_branch_target_buffer_glue;
     delete _component_branch_target_buffer_register;
-
+    
     delete _component;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Parameters.h	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Parameters.h	(revision 115)
@@ -44,7 +44,7 @@
                                                
   public : Thistory_t _bht_history_mask        ;
-  public : Thistory_t _bht_history_rshift      ;
+  public : Thistory_t _bht_history_shift       ;
   public : Thistory_t _pht_history_mask        ;
-  public : Thistory_t _pht_history_rshift      ;
+  public : Thistory_t _pht_history_shift       ;
                                                
   public : uint32_t   _bht_size_address        ;
@@ -55,7 +55,7 @@
   public : uint32_t   _pht_size_bank           ;
   public : Taddress_t _pht_address_share_mask  ;
-  public : Taddress_t _pht_address_share_lshift;
+  public : Taddress_t _pht_address_share_shift ;
   public : Taddress_t _pht_address_bank_mask   ;
-  public : Taddress_t _pht_address_bank_rshift ;
+  public : Taddress_t _pht_address_bank_shift  ;
 
   public : Thistory_t _bht_init_take           ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Two_Level_Branch_Predictor.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Two_Level_Branch_Predictor.h	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Two_Level_Branch_Predictor.h	(revision 115)
@@ -88,5 +88,5 @@
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
   private   : Thistory_t                    * reg_BHT                       ;//[bht_nb_shifter]
-  private   : Thistory_t                   ** reg_PHT                       ;//[pht_nb_counter][pht_nb_bank]
+  private   : Thistory_t                   ** reg_PHT                       ;//[pht_nb_bank][pht_size_bank]
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Parameters.cpp	(revision 114)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Parameters.cpp	(revision 115)
@@ -57,18 +57,25 @@
     //  MSB : pht_history
     //  LSB : bht_history
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _have_bht                 : %d",_have_bht        );
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _bht_size_shifter         : %d",_bht_size_shifter);
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _bht_nb_shifter           : %d",_bht_nb_shifter  );
+
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _have_pht                 : %d",_have_pht        );
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_size_counter         : %d",_pht_size_counter);
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_nb_counter           : %d",_pht_nb_counter  );
                        
     _size_history            = _bht_size_shifter + _pht_size_counter;
     _bht_history_mask        = gen_mask<Thistory_t>(_bht_size_shifter);
-    _bht_history_rshift      = 0;
+    _bht_history_shift       = 0;
     _pht_history_mask        = gen_mask<Thistory_t>(_pht_size_counter);
-    _pht_history_rshift      = _bht_size_shifter;
+    _pht_history_shift       = _bht_size_shifter;
                              
     log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _size_history             : %d",_size_history  );
     log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _bht_history_mask         : 0x%x",_bht_history_mask  );
-    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _bht_history_rshift       : %d",_bht_history_rshift);
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _bht_history_shift        : %d",_bht_history_shift );
     log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_history_mask         : 0x%x",_pht_history_mask  );
-    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_history_rshift       : %d",_pht_history_rshift);
+    log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_history_shift        : %d",_pht_history_shift );
 
-    _bht_init_take           = (Thistory_t)(-1)&_bht_history_mask;
+    _bht_init_take           = static_cast<Thistory_t>(-1)&_bht_history_mask;
     _bht_init_ntake          = 0;
     _pht_init_take           = (1<<(_pht_size_counter-1)); // size = 4 : 1000/2
@@ -91,18 +98,26 @@
         _pht_counter_max         = (1<<_pht_size_counter)-1;
         
-        _pht_nb_bank             = (_pht_nb_counter - (1<<_bht_size_shifter))+1;
-        _pht_size_bank           = _pht_nb_counter / _pht_nb_bank;
+        _pht_size_bank           = (_have_bht)?(1<<_bht_size_shifter):1;
+        _pht_nb_bank             = _pht_nb_counter / _pht_size_bank;
+
+	// -------->|
+	//   +---+  |
+	//   |   |  |--->
+	// ---> --->|
+	//   |   |  |
+	//   +---+
+	//
 
         _pht_address_share_mask  = gen_mask<Taddress_t>(_pht_size_address_share);
-        _pht_address_share_lshift= _bht_size_shifter-_pht_size_address_share;
+        _pht_address_share_shift = _bht_size_shifter-_pht_size_address_share;
         _pht_address_bank_mask   = gen_mask<Taddress_t>(log2(_pht_nb_bank));
-        _pht_address_bank_rshift = _pht_size_address_share;
+        _pht_address_bank_shift  = _pht_size_address_share;
 
         log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_nb_bank              : %d"  ,_pht_nb_bank   );
         log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_size_bank            : %d"  ,_pht_size_bank );
         log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_share_mask   : 0x%x",_pht_address_share_mask  );
-        log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_share_lshift : %d"  ,_pht_address_share_lshift);
+        log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_share_shift  : %d"  ,_pht_address_share_shift );
         log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_bank_mask    : 0x%x",_pht_address_bank_mask   );
-        log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_bank_rshift  : %d"  ,_pht_address_bank_rshift );
+        log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * _pht_address_bank_shift   : %d"  ,_pht_address_bank_shift  );
       }
 
